module TYCiCore
	class Command
		class Lib < Command
			class Create < Lib
				self.abstract_command = false
				self.summary = "custom module git branch create"
				self.command = 'custom_branch'

				def self.options
					[
						['--path=target_path', '--path target path a ci local module'],
						['--tag=0.0.1', '--tag tag'],
						['--branch=new_branch', '--branch new branch'],
						['--temp=temp_path', '--temp a temp path']
					].concat(super)
				end

				def validate!
					help! "path need" unless @path
					help! "tag need" unless @tag
					help! "branch need" unless @branch
					help! "temp need" unless @temp
				end

				def initialize(argv)
					super
					@path = argv.option('path')
					@tag = argv.option('tag')
					@branch = argv.option('branch')
					@temp = argv.option('temp')
				end

				def run
					require 'tuya/ci/core'
					TYGit.checkout_custom_branch(@path, @tag, @branch, @temp)
				end
			end
		end
	end
end