module TYCiCore
	class TYPodNode

		attr_accessor :node_dep, :parent, :nodes, :pod_item

		def initialize
			@node_dep = 0
			@parent = ''
			@nodes = Hash.new
			@pod_item = nil
		end

		def join_node(node)
			node.parent = @pod_item.name
			nodes[node.pod_item.name] = node
		end

		def add_pod_item(item)
			@pod_item = item if item
		end
	end

	class TYPodItem
		attr_accessor :name, :dependency, :dependency_list
		def initialize(name)
			@name = name
			@dependency = false
			@dependency_list = nil
		end
	end

	class TYPodOrder
		attr_accessor :pods, :group
		def initialize(order, pods)
			@group = order
			@pods = pods
		end
	end
end