require 'tuya/ci/core/util/dir'
require 'tuya/ci/core/util/file'

module TYCiCore
	class PodSpec

		attr_accessor :file
		attr_accessor :content

		def initialize(podspec)

			puts "Tuya podspec is #{podspec}".green

			raise 'podspec cannot be nil' unless podspec

			@podspec_json = podspec_json? podspec
			@file = TYUtil::TYFile.podspec_files(podspec)[0]
			@content = File.read(@file)
		end

		def value_key(key)
			if @podspec_json
				content_json = JSON @content
			else
				content_temp = TYCiCore::EXE.exe 'pod', %W(ipc spec #{@file}), true

				content_temp = content_temp.match(/^\{.*\}$/m)[0]
				puts content_temp

				content_json = JSON content_temp
			end
			eval("content_json" << key.split('/').map { |i| "[\"" + i + "\"]" }.join) if content_json
		end

		def update(key, value)
			unless @podspec_json
				puts "Podspec: #{@file} update key: #{key} value: #{value}".green

				res = @content.scan(/.#{key}\s*=\s*'#{value}'/)
				need_update = res.size == 0
				if need_update
					@content.gsub!(/s.#{key}\s*=(.*?)'$/, "s.#{key}          = '#{value}'")
				end
				need_update
			end
		end

		def update_add(key, value, output=true)
			unless @podspec_json
				puts "Podspec: #{@file} update_add key: #{key} value: #{value}".green if output
				res = @content.scan(/.#{key}\s*=\s*/)
				key_is_exist = res.size == 0
				puts key_is_exist
				if key_is_exist
					@content = TYUtil::TYFile.add_to_line @content, value, 8
				else
					@content.gsub!(/s.#{key}\s*=(.*?)'$/, "s.#{key}          = #{value}")
				end
				key_is_exist
			end
		end

		def save
			puts "Podspec: #{@file} saved".green
			fh = File.new(@file, "w")
			fh.puts @content
			fh.close
		end

		def podspec_json?(podspec)
			podspec.scan(/podspec.json$/).size > 0
		end
	end
end