require 'open-uri'

module TYCiCore

	class RepoRelease

		def release(module_name, version)
			puts "Ready to release #{module_name} : #{version}".green

			config =  RepoReleaseCIConfig.new module_name, version

			config.config.each do |item|
				release_item item
			end

		end

		def release_item(item)
			item.ready
			if item_lint item
				repo_release_git = RepoReleaseGit.new
				repo_release_git.prepare item
				# download_release_content item
			end
		end

		def download_release_content(item)
			podspec = TYCiCore::PodSpec.new item.podspec
			url = podspec.value_key 'source/http'
			zip_path = TYCiCore::TYDownload.download url, url.split('/')[-1]

			TYUtil::TYFile.unzip zip_path, './tmp'
			TYUtil::TYFile.delete zip_path

		end

		def item_lint(item)
			exist = File.exist? item.podspec
			puts "#{item.podspec} is not exist".red unless exist
			lint_result = exist
			lint_result
		end
	end
end