module TYCiCore
	class SpecODM

		attr_accessor :repo, :repo_url, :module_name, :module_version

		def initialize(repo, repo_url, module_name, module_version)
			@repo = repo
			@repo_url = repo_url
			@module_name = module_name
			@module_version = module_version

			home = ENV["HOME"]
			# /Users/dong/.cocoapods/repos/TYSpecs/Specs/TestDemo/12.0.8
			@repo_path = "#{home}/.cocoapods/repos/#{@repo}"
			# @repo_module_path = "#{@repo_path}/Specs/#{@module_name}/#{module_version}/"
			@repo_module_path = "#{@repo_path}/#{@module_name}/#{module_version}/"
		end

		def odm_config
			add_repo unless spec_exist?
			repo_update
			podspec_des
		end

		def add_repo
			TYCiCore::EXE.exe 'pod', %W(repo add #{@repo} #{@repo_url})
		end

		def podspec_des
			podspec_path = "#{@repo_module_path}#{@module_name}.podspec"
			puts "ODM #{module_name}'s podspec path is #{podspec_path}".yellow

			podspec = TYCiCore::PodSpec.new podspec_path
			podspec.value_key 'summary'
		end

		def repo_update
			puts "ODM pod repo update #{@repo}".yellow
			TYCiCore::EXE.exe 'pod', %W(repo update #{@repo})
		end

		def spec_exist?
			result = File.exist? @repo_path
			puts "ODM repo: #{@repo} exist? #{result}".yellow
			result
		end
	end
end