module TYCiCore

	class RepoReleaseCIConfig
		def initialize(module_name, version)
			@module_name = module_name
			@version = version
		end

		def config
			sdk =  RepoReleaseCIConfigSDK.new
			is_sdk = sdk.module_sdk? @module_name
			result = []
			if is_sdk
			else
				result << RepoReleaseConfig.new(@module_name, @version, @module_name, 'master')
			end
			result
		end
	end

	#
	# {
	#     "path": "Spec",
	#     "project": "tuyasmart_home_ios_sdk",
	#     "repos": [
	#         "TuyaSmartBaseKit",
	#         "TuyaSmartDeviceKit",
	#         "TuyaSmartFeedbackKit"
	#     ]
	# }
	#
	class RepoReleaseCIConfigSDK
		@@path = '~/.ci_release/sdk/config/'
		def initialize
		end
		def module_sdk?(module_name)
			false
		end
	end

	class RepoReleaseConfig
		attr_accessor :path, :podspec, :project, :version
		attr_accessor :project_github_name, :project_github_url, :base_branch
		def initialize(module_name, version, project_github, base_branch)

			@path = "#{ENV['HOME']}/.cocoapods/repos/TYSpecs/Specs/#{module_name}/#{version}/"

			@podspec = "#{path}#{module_name}.podspec"
			if version.split('.').size == 4
				@podspec = "#{path}#{module_name}.podspec.json"
			end

			@project = module_name
			@version = version

			@project_github_name = project_github
			@project_github_url = "https://github.com/TuyaInc/#{project_github}.git"
			@base_branch = base_branch
		end

		def ready
			puts "Release #{@project} : #{@version}, path : #{@path}".yellow
		end

	end

end